----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    04:57:53 02/03/2010 
-- Design Name: 
-- Module Name:    dso_block - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

-----------------------------------------------------------
--
-- fW^IV CW[
-- |[g}bv錾
--
-----------------------------------------------------------
entity dso_block is
	-- |[g}bv
	port (
		-- ADCf[^oX
		-- ADCNbNo
		-- CNbN
		Analog			:in		std_logic_vector (7 downto 0);
		Encode			:out	std_logic;
		MainClock		:in		std_logic;
		
		-- VAʐMNbN
		-- VAʐM(0:Data/1:Command)
		-- VAʐMf[^
		MCUCLK			:in		std_logic; 
		MCUDC			:in		std_logic; 
		MCUDAT			:in		std_logic;
		
		-- LCDf[^oX(R6G6B6)
		-- LCD
		-- LCD
		-- LCDNbN
		DispData		:out	std_logic_vector (17 downto 0);
		DispHSync		:out	std_logic; 
		DispVSync		:out	std_logic;
		DispClock		:out	std_logic;
		
		-- SRAM OE/WE M
		OutputEnableA	:out	std_logic; 
		OutputEnableB	:out	std_logic; 
		WriteEnableA	:out	std_logic; 
		WriteEnableB	:out	std_logic;
		
		-- SRAM AhX/f[^ oX
		AddrA			:out	std_logic_vector (15 downto 0); 
		AddrB			:out	std_logic_vector (15 downto 0);
		DataA			:inout	std_logic_vector (15 downto 0); 
		DataB			:inout	std_logic_vector (15 downto 0)
	);
	
end dso_block;


-----------------------------------------------------------
--
-- WbN
--
-----------------------------------------------------------
architecture Behavioral of dso_block is


-----------------------------------------------------------
-- MCUC^[tFCX
	component dso_control
	port (
		-- Oo̓|[g
		DC:			in		std_logic;
		Din:		in		std_logic;
		Dclk:		in		std_logic;
		
		-- o̓|[g
		bmpAddr:	out		std_logic_vector(10 downto 0);
		bmpData:	out		std_logic_vector(7 downto 0);
		TimeLength:	out		std_logic_vector(15 downto 0);
		TrigLevel:	out		std_logic_vector(7 downto 0);
		Intensity:	out		std_logic_vector(3 downto 0);
		Delay:		out		std_logic_vector(10 downto 0);
		PosEdge:	out		std_logic;
		NegEdge:	out		std_logic;
		Clock:		in		std_logic;
		Reset:		out		std_logic
	);
	end component;
	
	
-----------------------------------------------------------
-- fBXvC䃍WbN
	component dso_display
	port (
		-- Oo̓|[g
		Addr:		out		std_logic_vector(15 downto 0);
		oData:		out		std_logic_vector(15 downto 0);
		iData:		in		std_logic_vector(15 downto 0);
		OE:			out		std_logic;
		WE:			out		std_logic;

		gData:		out		std_logic_vector(17 downto 0);
		gHSync:		out		std_logic;
		gVSync:		out		std_logic;
		gClock:		out		std_logic;
		
		-- o̓|[g
		Intensity:	in		std_logic_vector(3 downto 0);
		TrigLevel:	in		std_logic_vector(7 downto 0);
		bmpAddr:	out		std_logic_vector(9 downto 0);
		bmpData:	in		std_logic_vector(15 downto 0);
		Reset:		in		std_logic;
		Clock:		in		std_logic;
		Stored:		in		std_logic;
		ClearBuff:	out		std_logic;
		Bank:		out		std_logic
	);
	end component;


-----------------------------------------------------------
-- gKWbN
	component dso_trig is
	port (
		iAnalog		:	in		std_logic_vector(7 downto 0);
		oAnalog		:	out		std_logic_vector(7 downto 0);
		Delay		:	in		std_logic_vector(10 downto 0);
		TrigLevel	:	in		std_logic_vector(7 downto 0);
		Trig		:	out		std_logic;
		PosEdge		:	in		std_logic;
		NegEdge		:	in		std_logic;
		Reset		:	in		std_logic;
		Clock		:	in		std_logic
	);
	end component;
	

-----------------------------------------------------------
-- fW^Xg[WubN
	component dso_storage is
	port (
		-- Oo̓|[g
		Addr:		out		std_logic_vector(15 downto 0);
		oData:		out		std_logic_vector(15 downto 0);
		iData:		in		std_logic_vector(15 downto 0);
		OE:			out		std_logic;
		WE:			out		std_logic;
		Analog:		in		std_logic_vector(7 downto 0);

		-- o̓|[g
		TimeLength:	in		std_logic_vector(15 downto 0);
		Trig:		in		std_logic;
		Reset:		in		std_logic;
		Stored:		out		std_logic;
		ClearBuff:	in		std_logic;
		Clock:		in		std_logic
	);
	end component;


-----------------------------------------------------------
-- oXXCb`W[
	component dso_page_switch
	port (
		-- Oo̓|[g
		ExAddrA:	out		std_logic_vector(15 downto 0);
		ExAddrB:	out		std_logic_vector(15 downto 0);
		ExDataA:	inout	std_logic_vector(15 downto 0);
		ExDataB:	inout	std_logic_vector(15 downto 0);
		ExOEnA:		out		std_logic;
		ExOEnB:		out		std_logic;
		ExWEnA:		out		std_logic;
		ExWEnB:		out		std_logic;
		
		-- o̓|[g
		InAddrA:	in		std_logic_vector(15 downto 0);
		InAddrB:	in		std_logic_vector(15 downto 0);
		InWriteA:	in		std_logic_vector(15 downto 0);
		InWriteB:	in		std_logic_vector(15 downto 0);
		InReadA:	out		std_logic_vector(15 downto 0);
		InReadB:	out		std_logic_vector(15 downto 0);
		InOEnA:		in		std_logic;
		InOEnB:		in		std_logic;
		InWEnA:		in		std_logic;
		InWEnB:		in		std_logic;
		
		Bank:		in		std_logic;
		Clock80:	in		std_logic;
		Clock180:	in		std_logic
	);
	end component;
	

-----------------------------------------------------------
-- [Jϐ̐錾	
	
	signal	DCM1CLK0:	std_logic;
	signal	DCM1CLK180:	std_logic;
	signal	DCM1FX:		std_logic;
	signal	DCM2CLK0:	std_logic;
	signal	DCM2CLK180:	std_logic;
	signal	IBUFG40	:	std_logic;

	signal	Clock40	:	std_logic;
	signal	Clock80	:	std_logic;
	signal	Clock0:		std_logic;
	signal	Clock180:	std_logic;
	signal	Reset	:	std_logic;

	signal	TimeLength:	std_logic_vector(15 downto 0);
	signal	TrigLevel:	std_logic_vector(7 downto 0);
	signal	Intensity:	std_logic_vector(3 downto 0);
	signal	Delay	:	std_logic_vector(10 downto 0);
	signal	PosEdge	:	std_logic;
	signal	NegEdge	:	std_logic;
	
	signal	mAnalog	:	std_logic_vector(7 downto 0);
	signal	mAddrA	:	std_logic_vector(15 downto 0);
	signal	oDataA	:	std_logic_vector(15 downto 0);
	signal	iDataA	:	std_logic_vector(15 downto 0);
	signal	mOEnA	:	std_logic;
	signal	mWEnA	:	std_logic;
	signal	Trig	:	std_logic;
	signal	Stored	:	std_logic;
	signal	ClearBuff:	std_logic;
	signal	Bank	:	std_logic;

	signal	mAddrB	:	std_logic_vector(15 downto 0);
	signal	oDataB	:	std_logic_vector(15 downto 0);
	signal	iDataB	:	std_logic_vector(15 downto 0);
	signal	mOEnB	:	std_logic;
	signal	mWEnB	:	std_logic;
	
	signal	bmpAddrA:	std_logic_vector(9 downto 0);
	signal	bmpAddrB:	std_logic_vector(10 downto 0);
	signal	bmpDataA:	std_logic_vector(15 downto 0);
	signal	bmpDataB:	std_logic_vector(7 downto 0);
	

-----------------------------------------------------------
--
-- 烍WbNLq
--
-----------------------------------------------------------
begin
	-- GCLKpbh̃NbN
	IBUFG1 : IBUFG
		port map(I=>MainClock, O=>IBUFG40);

	-- DCM140MHz{80MHz𐶐܂B
	DCM1 : DCM_SP
		generic map( CLK_FEEDBACK => "1X",
			CLKDV_DIVIDE		=> 2.0,
			CLKFX_DIVIDE		=> 8,
			CLKFX_MULTIPLY		=> 16,
			CLKIN_DIVIDE_BY_2	=> FALSE,
			CLKIN_PERIOD		=> 25.000,
			CLKOUT_PHASE_SHIFT	=> "NONE",
			DESKEW_ADJUST		=> "SYSTEM_SYNCHRONOUS",
			DFS_FREQUENCY_MODE	=> "LOW",
			DLL_FREQUENCY_MODE	=> "LOW",
			DUTY_CYCLE_CORRECTION => TRUE,
			FACTORY_JF			=> x"C080",
			PHASE_SHIFT			=> 0,
			STARTUP_WAIT		=> FALSE
		)
		port map(
			CLKFB	=> Clock40,
			CLKIN	=> IBUFG40,
			DSSEN	=> '0',
			PSCLK	=> '0',
			PSEN	=> '0',
			PSINCDEC=> '0',
			RST		=> '0',
			CLKDV	=> open,
			CLKFX	=> DCM1FX,
			CLKFX180=> open,
			CLK0	=> DCM1CLK0,
			CLK2X	=> open,
			CLK2X180=> open,
			CLK90	=> open,
			CLK180	=> DCM1CLK180,
			CLK270	=> open,
			LOCKED	=> open,
			PSDONE	=> open,
			STATUS	=> open
		);
		
	BUFG0 : BUFG
		port map(I=>DCM1CLK0, O=>Clock40);
	BUFG1 : BUFG
		port map(I=>DCM1CLK180, O=>Encode);
	BUFG2 : BUFG
		port map(I=>DCM1FX, O=>Clock80);
	
	
	-- DCM2ňʑ80MHzNbN𐶐܂
	DCM2 : DCM_SP
		generic map( CLK_FEEDBACK => "1X",
			CLKDV_DIVIDE		=> 2.0,
			CLKFX_DIVIDE		=> 1,
			CLKFX_MULTIPLY		=> 4,
			CLKIN_DIVIDE_BY_2	=> FALSE,
			CLKIN_PERIOD		=> 12.500, --12.5=80MHz --14.288=70MHz
			CLKOUT_PHASE_SHIFT	=> "FIXED",
			DESKEW_ADJUST		=> "SYSTEM_SYNCHRONOUS",
			DFS_FREQUENCY_MODE	=> "LOW",
			DLL_FREQUENCY_MODE	=> "LOW",
			DUTY_CYCLE_CORRECTION => TRUE,
			FACTORY_JF			=> x"C080",
			PHASE_SHIFT			=> 0, --32=45deg --64=90deg
			STARTUP_WAIT		=> FALSE
		)
		port map(
			CLKFB	=> Clock0,
			CLKIN	=> Clock80,
			DSSEN	=> '0',
			PSCLK	=> '0',
			PSEN	=> '0',
			PSINCDEC=> '0',
			RST		=> '0',
			CLKDV	=> open,
			CLKFX	=> open,
			CLKFX180=> open,
			CLK0	=> DCM2CLK0,
			CLK2X	=> open,
			CLK2X180=> open,
			CLK90	=> open,
			CLK180	=> open,
			CLK270	=> DCM2CLK180,
			LOCKED	=> open,
			PSDONE	=> open,
			STATUS	=> open
		);
		
	BUFG3 : BUFG
		port map(I=>DCM2CLK0, O=>Clock0);
	BUFG4 : BUFG
		port map(I=>DCM2CLK180, O=>Clock180);
		
	-- MCUC^[tFCX
	DsoControl : dso_control
		port map(
			-- Oo̓|[g
			DC		=> MCUDC,
			Din		=> MCUDAT,
			Dclk	=> MCUCLK,
			
			-- o̓|[g
			bmpAddr	=> bmpAddrB,
			bmpData => bmpDataB,
			TimeLength	=> TimeLength,
			TrigLevel	=> TrigLevel,
			Intensity	=> Intensity,
			Delay	=> Delay,
			PosEdge => PosEdge,
			NegEdge => NegEdge,
			Clock	=> Clock40,
			Reset	=> Reset
		);
	
	-- fBXvC䃍WbN
	DsoDisplay : dso_display
		port map(
			Addr	=> mAddrA,
			oData	=> oDataA,
			iData	=> iDataA,
			OE		=> mOEnA,
			WE		=> mWEnA,
			gData	=> DispData,
			gHSync	=> DispHSync,
			gVSync	=> DispVSync,
			gClock	=> DispClock,
			Intensity	=> Intensity,
			TrigLevel	=> TrigLevel,
			bmpAddr	=> bmpAddrA,
			bmpData	=> bmpDataA,
			Reset	=> Reset,
			Clock	=> Clock40,
			Stored	=> Stored,
			ClearBuff	=> ClearBuff,
			Bank	=> Bank
		);
		
	-- gKWbN
	DsoTrig : dso_trig
		port map (
			iAnalog		=> Analog,
			oAnalog		=> mAnalog,
			Delay		=> Delay,
			TrigLevel	=> TrigLevel,
			Trig		=> Trig,
			PosEdge		=> PosEdge,
			NegEdge		=> NegEdge,
			Reset		=> Reset,
			Clock		=> Clock40
		);
		
	-- f[^TvOWbN
	DsoStorage : dso_storage
		port map(
			Addr	=> mAddrB,
			oData	=> oDataB,
			iData	=> iDataB,
			OE		=> mOEnB,
			WE		=> mWEnB,
			Analog	=> mAnalog,
			TimeLength	=> TimeLength,
			Trig	=> Trig,
			Reset	=> Reset,
			Stored	=> Stored,
			ClearBuff	=> ClearBuff,
			Clock	=> Clock80
		);
		
	
	-- oXXCb`
	DsoPageSwitch : dso_page_switch
		port map(
			ExAddrA	=> AddrA,
			ExAddrB	=> AddrB,
			ExDataA	=> DataA,
			ExDataB	=> DataB,
			ExOEnA	=> OutputEnableA,
			ExOEnB	=> OutputEnableB,
			ExWEnA	=> WriteEnableA,
			ExWEnB	=> WriteEnableB,
			InAddrA	=> mAddrA,
			InAddrB	=> mAddrB,
			InWriteA=> oDataA,
			InWriteB=> oDataB,
			InReadA	=> iDataA,
			InReadB	=> iDataB,
			InOEnA	=> mOEnA,
			InOEnB	=> mOEnB,
			InWEnA	=> mWEnA,
			InWEnB	=> mWEnB,
			Bank	=> Bank,
			Clock80=> Clock0,
			Clock180=> Clock180
		);

	RAMB16BWE_S18_S9_inst : RAMB16BWE_S18_S9
		generic map (
			INIT_A => X"00000", --  Value of output RAM registers on Port A at startup
			INIT_B => X"000", --  Value of output RAM registers on Port B at startup
			SIM_COLLISION_CHECK => "ALL", -- "NONE", "WARNING", "GENERATE_X_ONLY", "ALL" 
			SRVAL_A => X"00000", --  Port A ouput value upon SSR assertion
			SRVAL_B => X"000", --  Port B ouput value upon SSR assertion
			WRITE_MODE_A => "READ_FIRST", --  WRITE_FIRST, READ_FIRST or NO_CHANGE
			WRITE_MODE_B => "READ_FIRST" --  WRITE_FIRST, READ_FIRST or NO_CHANGE
		)
		port map (
			DOA		=> bmpDataA,-- Port A 16-bit Data Output
			DOB		=> open,	-- Port B 8-bit Data Output
			DOPA	=> open,	-- Port A 2-bit Parity Output
			DOPB	=> open,	-- Port B 1-bit Parity Output
			ADDRA	=> bmpAddrA,-- Port A 10-bit Address Input
			ADDRB	=> bmpAddrB,-- Port B 11-bit Address Input
			CLKA	=> Clock40,	-- Port A 1-bit Clock
			CLKB	=> Clock40,	-- Port B 1-bit Clock
			DIA		=> X"0000",	-- Port A 16-bit Data Input
			DIB		=> bmpDataB,-- Port B 8-bit Data Input
			DIPA	=> "00",	-- Port A 2-bit parity Input
			DIPB	=> "0",		-- Port B 1-bit parity Input
			ENA		=> '1',		-- Port A 1-bit RAM Enable Input
			ENB		=> '1',		-- Port B 1-bit RAM Enable Input
			SSRA	=> '0',		-- Port A 1-bit Synchronous Set/Reset Input
			SSRB	=> '0',		-- Port B 1-bit Synchronous Set/Reset Input
			WEA		=> "00",	-- Port A 2-bit Write Enable Input
			WEB		=> '1'		-- Port B 1-bit Write Enable Input
		);
end Behavioral;

