library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;


-----------------------------------------------------------
--
-- MCUC^[tFCXсADSO䃍WbN
-- |[g}bv錾
--
-----------------------------------------------------------
entity dso_control is
	port (
		-- VAʐMNbN
		-- VAʐM(0:Data/1:Command)
		-- VAʐMf[^
		DC:			in		std_logic;
		Din:		in		std_logic;
		Dclk:		in		std_logic;
		
		-- j[VRAMAhX
		-- j[VRAMf[^
		bmpAddr:	out		std_logic_vector(10 downto 0);
		bmpData:	out		std_logic_vector(7 downto 0);
		
		-- |ԏo
		-- gKxo
		-- Pxo
		-- xԏo
		-- gKGbWo
		TimeLength:	out		std_logic_vector(15 downto 0)	:= X"0100";
		TrigLevel:	out		std_logic_vector(7 downto 0)	:= X"80";
		Intensity:	out		std_logic_vector(3 downto 0)	:= "0100";
		Delay:		out		std_logic_vector(10 downto 0)	:= "00000000000";
		PosEdge:	out		std_logic	:= '1';
		NegEdge:	out		std_logic	:= '0';
		
		-- W[NbN(40MHz)
		-- W[Zbg
		Clock:		in		std_logic;
		Reset:		out		std_logic	:= '1'
	);
end dso_control;
-----------------------------------------------------------


-----------------------------------------------------------
--
-- WbN
--
-----------------------------------------------------------
architecture Behavioral of dso_control is


	-- [Jϐ
	signal	DC0, DC1				:	std_logic;
	signal	ShiftClk0, ShiftClk1	:	std_logic;
	signal	DataBit					:	std_logic;
	
	signal	ShiftReg				:	std_logic_vector(7 downto 0);
	signal	SerialStat, xSerialStat	:	integer range 0 to 8;
	signal	InstByte				:	std_logic;
	signal	Instruction				:	std_logic_vector(7 downto 0);
	signal	DataIndex, xDataIndex	:	integer range 0 to 1;
	signal	bmpIndex, xbmpIndex		:	std_logic_vector(10 downto 0);
	signal	Work					:	std_logic_vector(7 downto 0);
	signal	RxIF, xRxIF				:	std_logic;

begin

	SerialStat <= xSerialStat;
	DataIndex <= xDataIndex;
	bmpIndex <= xbmpIndex;
	RxIF <= xRxIF;
	
	process ( Clock ) begin
	
	-- NbN̗オ蓮
	if ( Clock'event and Clock='1' ) then
	
		ShiftClk0 <= Dclk;
		ShiftClk1 <= ShiftClk0;
		DC0 <= DC;
		DataBit <= Din;
		
------------------------------------------------------------
-- SPINbN̗オŃf[^

		if ( ShiftClk0='1' and ShiftClk1='0' ) then
			
			-- MSB-first VtgWX^
			for i in 0 to 6 loop
				ShiftReg(i+1) <= ShiftReg(i);
			end loop;
			ShiftReg(0) <= DataBit;
			DC1 <= DC0;
			
			-- DCωœ܂
			if ( DC1/=DC0 ) then
				xSerialStat <= 1;
				InstByte <= DC0;
				xRxIF <= '0';
				
			-- f[^M
			elsif ( SerialStat<7 ) then
				xSerialStat <= SerialStat + 1;
				xRxIF <= '0';
				
			-- f[^M
			else
				xSerialStat <= 0;
				xRxIF <= '1';
			end if;
		else
			xRxIF <= '0';
		end if;
		
		
------------------------------------------------------------
-- MtOoAߎs

		if ( RxIF='1' ) then
					
			-- R}hoCgMAi[
			if ( InstByte='1' ) then
				Instruction <= ShiftReg;
				xDataIndex <= 0;
				
				-- PoCgR}h
				if ( ShiftReg=X"00" ) then
					Reset <= '1';
				else
					Reset <= '0';
				end if;
				
			-- |Ԑݒ
			elsif ( Instruction=X"10" ) then
			
				xDataIndex <= 1;
				if ( DataIndex=0 ) then
					Work <= ShiftReg;
				else
					TimeLength <= ShiftReg & Work;
				end if;
				
			-- gKx̐ݒ
			elsif ( Instruction=X"11" ) then
				TrigLevel <= ShiftReg;
				
			-- rbg}bvAhXZbg
			elsif ( Instruction=X"12" ) then
				
				if ( DataIndex=0 ) then
					xDataIndex <= 1;
					xbmpIndex <= ShiftReg & "000";
				else
					xbmpIndex <= bmpIndex + '1';
					bmpAddr <= bmpIndex;
					bmpData <= ShiftReg;
				end if;
				
			-- Px̐ݒ
			elsif ( Instruction=X"13" ) then
				Intensity <= ShiftReg(3 downto 0);
			
			-- |Ԑݒ
			elsif ( Instruction=X"14" ) then
			
				xDataIndex <= 1;
				if ( DataIndex=0 ) then
					Work <= ShiftReg;
				else
					Delay <= ShiftReg(2 downto 0) & Work;
				end if;
				
			-- etOݒ
			elsif ( Instruction=X"15" ) then
				PosEdge <= ShiftReg(0);
				NegEdge <= ShiftReg(1);
			end if;
		end if;
	end if;
	end process;

end Behavioral;
