----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    02:11:14 02/03/2010 
-- Design Name: 
-- Module Name:    dso_display - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

-----------------------------------------------------------
--
-- TvOf[^fBXvCɏo͂郍WbN
-- |[g}bv錾
--
-----------------------------------------------------------
entity dso_display is
	port (
		-- SRAM AhXoX
		-- SRAM o̓f[^oX
		-- SRAM OE/WE o
		Addr:		out		std_logic_vector(15 downto 0);
		oData:		out		std_logic_vector(15 downto 0);
		iData:		in		std_logic_vector(15 downto 0);
		OE:			out		std_logic := '1';
		WE:			out		std_logic := '1';

		-- LCDf[^oX(R6G6B6)
		-- LCD
		-- LCD
		-- LCDNbN
		gData:		out		std_logic_vector(17 downto 0);
		gHSync:		out		std_logic;
		gVSync:		out		std_logic;
		gClock:		out		std_logic;
		
		-- Pxݒ
		-- gKx
		Intensity:	in		std_logic_vector(3 downto 0);
		TrigLevel:	in		std_logic_vector(7 downto 0);
		
		-- j[VRAMAhX
		-- j[VRAMf[^
		bmpAddr:	out		std_logic_vector(9 downto 0);
		bmpData:	in		std_logic_vector(15 downto 0);
		
		-- W[Zbg
		-- W[NbN(40MHz)
		Reset:		in		std_logic;
		Clock:		in		std_logic;
		
		-- g`荞݊tO
		-- obt@NAtO
		-- SRAM oXXCb`o
		Stored:		in		std_logic;
		ClearBuff:	out		std_logic := '0';
		Bank:		out		std_logic := '1'
	);
end dso_display;

-----------------------------------------------------------
--
-- WbN
--
-----------------------------------------------------------
architecture Behavioral of dso_display is

	-- [Jϐ
	signal	CurrErase,	NextErase:		std_logic;
	signal	CurrBank,	NextBank:		std_logic;
	signal	Mult36:						std_logic_vector(35 downto 0);
	signal	iData18, Intensity18:		std_logic_vector(17 downto 0);
	signal	Work:						std_logic_vector(23 downto 0);
	signal	Bitmap:						std_logic_vector(15 downto 0);
	signal	IsVGrid:					std_logic;
	signal	Latch:						std_logic;

	signal	CurrHAddr,	NextHAddr:		integer range 0 to 3039;
	signal	CurrVAddr,	NextVAddr:		integer range 0 to 255;
	
	signal	DataR, DataG, DataB:		std_logic_vector(5 downto 0);

-----------------------------------------------------------
--
-- CvO
--
-----------------------------------------------------------
begin

	CurrHAddr <= NextHAddr;
	CurrVAddr <= NextVAddr;
	CurrBank <= NextBank;
	CurrErase <= NextErase;
	Bank <= CurrBank;
	
	-- SNbN
	process ( Clock )
	variable	HAddr:	std_logic_vector(11 downto 0);
	variable	VAddr:	std_logic_vector(7 downto 0);
	variable	temp:	std_logic_vector(16 downto 0);
	begin
	
	if ( Clock'event and Clock='1' ) then
	HAddr := CONV_std_logic_vector(CurrHAddr, 12);
	VAddr := CONV_std_logic_vector(CurrVAddr, 8);
	

------------------------------------------------------------
-- Ɛ̐Mo
	
	-- 
	if ( 2465<=CurrHAddr and CurrHAddr<2529 ) then
		gHSync <= '1';
		
		-- 
		if ( CurrVAddr=4 or CurrVAddr=5 ) then
			gVSync <= '1';
		end if;
	else
		gHSync <= '0';
		gVSync <= '0';
	end if;
	
	
	-- NbNo
	if ( HAddr(2)='0' ) then
		gClock <= '0';
	else
		gClock <= '1';
	end if;
	
	
	-- OtBbNo
	if ( HAddr(2 downto 0)="101" ) then
		
		-- g`\̈
		if ( HAddr(11)='0' ) then
			gData <= DataB & DataG & DataR;
			
		-- CtH[V̈
		elsif ( Bitmap(0)='1' ) then
			gData <= (others => '1');
		else
			gData <= (others => '0');
		end if;
	end if;
	
	
	-- WorkWX^Ƀf[^i[ς
	-- TvOf[^ɉĕ`F̖xvZ܂
	if ( HAddr(2 downto 0)="011" ) then
		DataB <= (others => '0');
		
		if ( Work<X"0000FF" ) then
			DataR <= Work(7 downto 2);
			if ( Work(7 downto 2)<"111111" ) then
				DataG <= Work(7 downto 2) + Work(1);
			else
				DataG <= Work(7 downto 2);
			end if;
		
		-- Oa͖xőɂ܂
		else
			DataR <= "111111";
			DataG <= "111111";
		end if;
		
	-- Obh`悵܂
	elsif ( HAddr(2 downto 0)="100" ) then
	
		-- gKx\܂
		if ( VAddr=TrigLevel and CurrHAddr<40 ) then
		
			DataR <= "111111";
			DataG <= "000000";
			DataB <= "000000";
		
		-- ObhZ܂
		elsif ( IsVGrid='1' or HAddr(7 downto 3)="11111" ) then
			
			DataB <= "001000";
			if ( DataR<"110111" ) then
				DataR <= DataR + "001000";
			else
				DataR <= "111111";
			end if;
			
			if ( DataG<"110111" ) then
				DataG <= DataG + "001000";
			else
				DataG <= "111111";
			end if;
		end if;
	end if;
	
	-- Obh𔻒肵܂
	case ( CurrVAddr ) is
		when 35|60|85|110|135|160|185|210|235 => IsVGrid <= '1';
		when others => IsVGrid <= '0';
	end case;

	-- rbg}bvAhXw
	if ( HAddr(6 downto 0)="0000000" ) then
		bmpAddr <= VAddr & HAddr(8 downto 7);
		
	-- rbg}bv̓ǂݍ
	elsif ( HAddr(6 downto 0)="0000010" ) then
		Bitmap <= bmpData;
		
	-- PhbgɃf[^Vtg
	elsif ( HAddr(2 downto 0)="010" ) then
		for i in 0 to 14 loop
			Bitmap(i) <= Bitmap(i+1);
		end loop;
	end if;
------------------------------------------------------------
-- TvOf[^̓o
	
	
	-- g`\̈
	if ( HAddr(11)='0' ) then
		
		-- ZbgL
		if ( Reset='1' ) then
			OE <= '1';
			WE <= '1';
		
		-- AhXZbgAǂݏov
		-- "010"ɂēǂݏof[^b`
		elsif ( HAddr(2 downto 0)="000" ) then
			Addr <= VAddr & HAddr(10 downto 3);
			OE <= '0';
			WE <= '1';
		
		-- Zʂb`܂
		elsif ( HAddr(2 downto 0)="011" ) then
			OE <= '1';
			WE <= '1';
--			temp := ("1" & Work) - '1';
--			if ( temp(16)='0' ) then
--				temp := (others => '0');
--			end if;
--			oData <= temp(15 downto 0);
			oData <= (others => '0');

		-- Zʂ݂܂
		elsif ( HAddr(2 downto 0)="100" ) then
			OE <= '1';
			WE <= not CurrErase;
			
		-- ̑̓ANZXȂ
		else
			OE <= '1';
			WE <= '1';
		end if;
		
	-- \̈O̓f[^o͂Ȃ
	else
		OE <= '1';
		WE <= '1';
	end if;

------------------------------------------------------------
-- Xe[g}V֘A

	-- Zbg
	if ( Reset='1' ) then
		NextHAddr <= 0;
		NextVAddr <= 0;
		NextErase <= '0';
		NextBank <= '0';
		ClearBuff <= '0';
	
	-- Co
	elsif ( CurrHAddr<3039 ) then
		NextHAddr <= CurrHAddr + 1;
		ClearBuff <= '0';
		
	-- PCI
	elsif ( CurrVAddr>0 ) then
		NextHAddr <= 0;
		NextVAddr <= CurrVAddr - 1;
	
	-- Pt[I
	else
		NextHAddr <= 0;
		NextVAddr <= 255;
		
		-- Xg[WĂ΃obt@NA܂
		if ( CurrErase='0' ) then
			NextErase <= Stored;
			
		-- obt@NAAoN؂ւ܂
		else
			NextErase <= '0';
			ClearBuff <= '1';
			NextBank <= not CurrBank;
		end if;
	end if;
	end if;
	end process;
	

------------------------------------------------------------
-- PxsZ

	-- TvOf[^̃b`^C~Oo
	process ( CurrHAddr )
	variable HAddr :	std_logic_vector(11 downto 0);
	begin
		HAddr := CONV_std_logic_vector(CurrHAddr, 12);
		case ( HAddr(2 downto 0) ) is
			when "010" => Latch <= '1';
			when others => Latch <= '0';
		end case;
	end process;
	
	-- Px16bitfR[_
	process ( Intensity )
	variable temp :		std_logic_vector(15 downto 0);
	begin
		temp := (others => '0');
		temp(CONV_integer(Intensity)) := '1';
		Intensity18 <= "00" & temp;
	end process;
	
	-- Ž
	Work <= Mult36(31 downto 8);
	iData18 <= "00" & iData;
	MULT18X18SIO_inst : MULT18X18SIO
		generic map (
			AREG => 1, -- Enable the input registers on the A port (1=on, 0=off)
			BREG => 1, -- Enable the input registers on the B port (1=on, 0=off)
			B_INPUT => "DIRECT", -- B cascade input "DIRECT" or "CASCADE" 
			PREG => 1) -- Enable the input registers on the P port (1=on, 0=off)
		port map (
			BCOUT => open, -- 18-bit cascade output
			P => Mult36,    -- 36-bit multiplier output
			A => iData18,    -- 18-bit multiplier input
			B => Intensity18, -- 18-bit multiplier input
			BCIN => (others => '0'), -- 18-bit cascade input
			CEA => Latch, -- Clock enable input for the A port
			CEB => Latch, -- Clock enable input for the B port
			CEP => '1', -- Clock enable input for the P port 
			CLK => Clock,    -- Clock input
			RSTA => '0', -- Synchronous reset input for the A port
			RSTB => '0', -- Synchronous reset input for the B port
			RSTP => '0' -- Synchronous reset input for the P port
		);

end Behavioral;

