library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

-----------------------------------------------------------
--
-- TvOf[^SRAMɊi[郍WbN
-- |[g}bv錾
--
-----------------------------------------------------------
entity dso_storage is
	port (
		-- SRAM AhXoX
		-- SRAM o̓f[^oX
		-- SRAM OE/WE o
		-- TvOf[^x
		Addr:		out		std_logic_vector(15 downto 0);
		oData:		out		std_logic_vector(15 downto 0);
		iData:		in		std_logic_vector(15 downto 0);
		OE:			out		std_logic := '1';
		WE:			out		std_logic := '1';
		Analog:		in		std_logic_vector(7 downto 0);

		-- |Ԑݒ
		-- gK
		TimeLength:	in		std_logic_vector(15 downto 0);
		Trig:		in		std_logic;
		
		-- g`荞݊tO
		-- obt@NAtO
		Stored:		out		std_logic := '0';
		ClearBuff:	in		std_logic;
		
		-- W[Zbg
		-- W[NbN(80MHz)
		Reset:		in		std_logic;
		Clock:		in		std_logic
	);
end dso_storage;
-----------------------------------------------------------


-----------------------------------------------------------
--
-- WbN
--
-----------------------------------------------------------
architecture Behavioral of dso_storage is
	
	-- [Jϐ
	signal	PrevAddr:		std_logic_vector(15 downto 0);
	signal	CurrTime:		std_logic_vector(7 downto 0);
	signal	NextTime:		std_logic_vector(7 downto 0);
	signal	CurrState:		integer range 0 to 1 := 0;
	signal	NextState:		integer range 0 to 1;
	signal	CurrMode:		integer range 0 to 1;
	signal	NextMode:		integer range 0 to 1;
	signal	AData:			std_logic_vector(7 downto 0);
	
	signal	CurrDiv:		std_logic_vector(15 downto 0);
	signal	NextDiv:		std_logic_vector(15 downto 0);
	signal	TimeTick:		std_logic;

	signal	CurrFrame:		integer range 0 to 2 := 1;
	signal	NextFrame:		integer range 0 to 2;


-----------------------------------------------------------
--
-- CvO
--
-----------------------------------------------------------
begin
	-- Xe[gXV܂
	CurrTime <= NextTime;
	CurrState <= NextState;
	CurrMode <= NextMode;
	CurrDiv <= NextDiv;
	CurrFrame <= NextFrame;


	-- NbNCxg
	process ( Clock )
	variable	temp:	std_logic_vector(16 downto 0);
	begin

------------------------------------------------------------
-- ADC GR[hNbNo͂ƃoN؂ւ^C~O
	
	if ( Clock'event and Clock='1' ) then

		-- Ńf[^z[h
		if ( CurrState=0 ) then
			AData <= Analog;
		end if;
	end if;


------------------------------------------------------------
-- f[^Xg[W

	-- オGbW
	if ( Clock'event and Clock='1' ) then

		-- f[^Xg[W
		if ( Reset='1' ) then
			WE <= '1';
			OE <= '1';

		-- gK҂
		elsif ( CurrMode=0 ) then
			WE <= '1';
			OE <= '1';

		-- ADC͂ƃ[hvAMf[^̉Z
		elsif ( CurrState=0 ) then
			WE <= '1';
			OE <= '0';
			Addr <= Analog & CurrTime;
			
--			temp := ("0" & iData) + '1';
--			if ( temp(16)='1' ) then
--				temp := "11111111111111111";
--			end if;
--			oData <= temp(15 downto 0);
--			oData <= iData + '1';

		-- ߖOaZƏ݃f[^ZbgAAhXҔ
		else

			-- pCvC1ڂ͏݂Ȃ
			if ( CurrTime>X"00" or CurrDiv>X"0000" ) then
				WE <= '0';
			else
				WE <= '1';
			end if;

			OE <= '1';
			oData <= iData + '1';
			Addr <= PrevAddr;
			PrevAddr <= AData & CurrTime;
		end if;
	end if;


------------------------------------------------------------
-- vXP[֘A

	if ( Clock'event and Clock='1' ) then
		
		if ( CurrState=0 ) then
			
			if ( CurrDiv<TimeLength ) then
				NextDiv <= CurrDiv + '1';
				TimeTick <= '0';
			else
				NextDiv <= (others => '0');
				TimeTick <= '1';
			end if;
		end if;
	end if;

------------------------------------------------------------
-- Xe[g}V֘A

	if ( Clock'event and Clock='1' ) then
		
		-- Zbg
		if ( Reset='1' ) then
			NextState <= 0;
			NextTime <= X"00";
			NextMode <= 0;

		-- gK҂
		elsif ( CurrMode=0 ) then

			if ( CurrState<1 ) then
				NextState <= CurrState + 1;

			elsif ( Trig='1' ) then
				NextState <= 0;
				NextMode <= 1;

			else
				NextState <= 0;
			end if;

		-- TvO
		else

			-- TvOXe[g
			if ( CurrState<1 ) then
				NextState <= CurrState + 1;

			-- vXP[
			elsif ( TimeTick='0' ) then
				NextState <= 0;

			-- Ԃi߂܂
			elsif ( CurrTime<X"FF" ) then
				NextState <= 0;
				NextTime <= CurrTime + '1';

			-- TvOIAgK҂
			else
				NextState <= 0;
				NextMode <= 0;
				NextTime <= (others => '0');
			end if;
		end if;

		-- gKҋ@̃oN؂ւȂA1pXŊ
		if ( CurrMode<1 ) then
			if ( ClearBuff='1' ) then
				NextFrame <= 1;
				Stored <= '0';
			end if;

		else			
			-- TvÕoN؂ւ́A2pXŊ
			if ( ClearBuff='1' ) then
				NextFrame <= 0;
				Stored <= '0';

			elsif ( CurrState=0 and TimeTick='1' and CurrTime=X"FF" ) then
				if ( CurrFrame=0 ) then
					NextFrame <= 1;
					Stored <= '0';

				elsif ( CurrFrame=1 ) then
					NextFrame <= 2;
					Stored <= '1';
				end if;
			end if;
		end if;
	end if;
	end process;

end Behavioral;
-----------------------------------------------------------
