
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   03:29:39 02/04/2010
-- Design Name:   dso_block
-- Module Name:   C:/TEMP/XilinxProgrami/dso_project10/dso_testbench01.vhd
-- Project Name:  dso_project10
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: dso_block
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.ALL;

ENTITY dso_testbench01_vhd IS
END dso_testbench01_vhd;

ARCHITECTURE behavior OF dso_testbench01_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT dso_block
	PORT(
		Analog : IN std_logic_vector(7 downto 0);
		MainClock : IN std_logic;
		MCUCLK : IN std_logic;
		MCUDC : IN std_logic;
		MCUDAT : IN std_logic;    
		DataA : INOUT std_logic_vector(15 downto 0);
		DataB : INOUT std_logic_vector(15 downto 0);      
		Encode : OUT std_logic;
		DispData : OUT std_logic_vector(17 downto 0);
		DispHSync : OUT std_logic;
		DispVSync : OUT std_logic;
		DispClock : OUT std_logic;
		OutputEnableA : OUT std_logic;
		OutputEnableB : OUT std_logic;
		WriteEnableA : OUT std_logic;
		WriteEnableB : OUT std_logic;
		AddrA : OUT std_logic_vector(15 downto 0);
		AddrB : OUT std_logic_vector(15 downto 0)
		);
	END COMPONENT;

	--Inputs
	SIGNAL MainClock :  std_logic := '0';
	SIGNAL MCUCLK :  std_logic := '0';
	SIGNAL MCUDC :  std_logic := '0';
	SIGNAL MCUDAT :  std_logic := '0';
	SIGNAL Analog :  std_logic_vector(7 downto 0) := (others=>'0');

	--BiDirs
	SIGNAL DataA :  std_logic_vector(15 downto 0);
	SIGNAL DataB :  std_logic_vector(15 downto 0);

	--Outputs
	SIGNAL Encode :  std_logic;
	SIGNAL DispData :  std_logic_vector(17 downto 0);
	SIGNAL DispHSync :  std_logic;
	SIGNAL DispVSync :  std_logic;
	SIGNAL DispClock :  std_logic;
	SIGNAL OutputEnableA :  std_logic;
	SIGNAL OutputEnableB :  std_logic;
	SIGNAL WriteEnableA :  std_logic;
	SIGNAL WriteEnableB :  std_logic;
	SIGNAL AddrA :  std_logic_vector(15 downto 0);
	SIGNAL AddrB :  std_logic_vector(15 downto 0);

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: dso_block PORT MAP(
		Analog => Analog,
		Encode => Encode,
		MainClock => MainClock,
		MCUCLK => MCUCLK,
		MCUDC => MCUDC,
		MCUDAT => MCUDAT,
		DispData => DispData,
		DispHSync => DispHSync,
		DispVSync => DispVSync,
		DispClock => DispClock,
		OutputEnableA => OutputEnableA,
		OutputEnableB => OutputEnableB,
		WriteEnableA => WriteEnableA,
		WriteEnableB => WriteEnableB,
		AddrA => AddrA,
		AddrB => AddrB,
		DataA => DataA,
		DataB => DataB
	);

	tb : PROCESS
	variable temp 	:	std_logic_vector(15 downto 0);
	variable data	:	std_logic_vector(7 downto 0);
	variable index	:	integer range 0 to 7;
	variable te		:	std_logic;
	BEGIN

	Analog <= transport "00000000";
	Analog <= transport "11000000" after 4us;
	Analog <= transport "00000000" after 8us;
	Analog <= transport "11000000" after 12us;
	Analog <= transport "00000000" after 1008us;
	Analog <= transport "11000000" after 1012us;

	DataA <= transport "LLLLLLLL" & "LLLLLLLL";
	DataB <= transport "LLLLLLLL" & "LLLLLLLL";

	for i in 0 to 100000 loop
		
		-- SRAMf[^o
		temp := CONV_std_logic_vector(i, 16);
		for i in 0 to 15 loop
			if ( temp(i)='1' ) then
				DataB(i) <= transport 'H';
			else
				DataB(i) <= transport 'L';
			end if;
		end loop;
		
		-- VAf[^o
		if ( i=16 ) then
			MCUDC <= transport '0';
			data := X"65";
			index := 7;
			te := '1';
		elsif ( i=16+80*1 ) then
			MCUDC <= transport '1';
			data := X"00";
			index := 7;
			te := '1';
		elsif ( i=16+80*2 ) then
			MCUDC <= transport '1';
			data := X"01";
			index := 7;
			te := '1';
		elsif ( i=16+80*3 ) then
			MCUDC <= transport '1';
			data := X"12";
			index := 7;
			te := '1';
		elsif ( i=16+80*4 ) then
			MCUDC <= transport '0';
			data := X"00";
			index := 7;
			te := '1';
		elsif ( i=16+80*5 ) then
			MCUDC <= transport '0';
			data := X"55";
			index := 7;
			te := '1';
		elsif ( i=16+80*6 ) then
			MCUDC <= transport '0';
			data := X"77";
			index := 7;
			te := '1';
		end if;
		
		-- MCUCLKo
		if ( (i mod 10)=0 ) then
			MCUDAT <= transport data(index);
			MCUCLK <= transport '0';
			
		elsif ( (i mod 10)=5 ) then
			if ( te='1' ) then
				MCUCLK <= transport '1';
			end if;
			
			if ( index>0 ) then
				index := index - 1;
			else
				te := '0';
			end if;
		end if;
		
		-- 40MHz-MainClocko
		MainClock <= transport '1';
		wait for 12.5ns;
		MainClock <= transport '0';
		wait for 12.5ns;
	end loop;

	for t in 0 to 100000 loop
		
		if ( t=10 ) then
			MCUDC <= transport '1';
			data := X"00";
			index := 7;
		end if;

		MCUDAT <= transport data(index);
		if ( index>0 ) then
			index := index - 1;
		end if;
		
		MCUCLK <= transport '0';
		wait for 0.1us;
		MCUCLK <= transport '1';
		wait for 0.1us;
	end loop;
	
	wait; -- will wait forever
	END PROCESS;

END;
