----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    12:52:48 03/01/2010 
-- Design Name: 
-- Module Name:    dso_trig - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;


-----------------------------------------------------------
--
-- TvOf[^̃gKуfBCWbN
-- |[g}bv錾
--
-----------------------------------------------------------
entity dso_trig is
	port (
		-- ADCf[^̓oX
		-- TvOf[^xo
		iAnalog		:	in		std_logic_vector(7 downto 0);
		oAnalog		:	out		std_logic_vector(7 downto 0);
		
		-- xݒ
		-- gKx
		-- gKMo
		-- gKGbWݒ
		Delay		:	in		std_logic_vector(10 downto 0);
		TrigLevel	:	in		std_logic_vector(7 downto 0);
		Trig		:	out		std_logic;
		PosEdge		:	in		std_logic;
		NegEdge		:	in		std_logic;
		
		-- W[Zbg
		-- W[NbN(40MHz)
		Reset		:	in		std_logic;
		Clock		:	in		std_logic
	);
end dso_trig;
-----------------------------------------------------------


-----------------------------------------------------------
--
-- WbN
--
-----------------------------------------------------------
architecture Behavioral of dso_trig is

------------------------------------------------------------
-- e탍[Jϐ
	signal	AddrA, xAddrA	:	std_logic_vector(10 downto 0);
	signal	AddrB, xAddrB	:	std_logic_vector(10 downto 0);
	signal	DataA			:	std_logic_vector(7 downto 0);
	signal	State, xState	:	integer range 0 to 1;

-----------------------------------------------------------
--
-- 烁CvO
--
-----------------------------------------------------------
begin
	AddrA <= xAddrA;
	AddrB <= xAddrB;
	State <= xState;

	process ( Clock )
	variable addr_a, addr_b	:	std_logic_vector(11 downto 0);
	begin
	if ( Clock'event and Clock='1' ) then
		
		-- TvOf[^̎擾
		DataA <= iAnalog;
	
		
		-- Zbg̓
		if ( Reset='1' ) then
			xAddrA <= (others => '0');
		
		-- ݃AhX̃CNg
		else
			addr_a := ("0" & AddrA) + '1';
			xAddrA <= addr_a(10 downto 0);
		end if;

		-- ǂݍ݃AhX̍ČvZ
		addr_b := ("1" & AddrA) - ("0" & Delay);
		xAddrB <= addr_b(10 downto 0);
		
		
		-- Zbg̓
		if ( Reset='1' ) then
			xState <= 0;
			Trig <= '0';
		
		-- 茟o
		elsif ( State=0 and DataA<TrigLevel ) then
			xState <= 1;
			Trig <= NegEdge;
			
		-- オ茟o
		elsif ( State=1 and DataA>TrigLevel ) then
			xState <= 0;
			Trig <= PosEdge;
		else
			Trig <= '0';
		end if;
	end if;
	end process;

	RAMB16_S9_S9_inst : RAMB16_S9_S9
		generic map (
			INIT_A => X"000", --  Value of output RAM registers on Port A at startup
			INIT_B => X"000", --  Value of output RAM registers on Port B at startup
			SRVAL_A => X"000", --  Port A ouput value upon SSR assertion
			SRVAL_B => X"000", --  Port B ouput value upon SSR assertion
			WRITE_MODE_A => "READ_FIRST", --  WRITE_FIRST, READ_FIRST or NO_CHANGE
			WRITE_MODE_B => "READ_FIRST", --  WRITE_FIRST, READ_FIRST or NO_CHANGE
			SIM_COLLISION_CHECK => "ALL" -- "NONE", "WARNING", "GENERATE_X_ONLY", "ALL" 
		)
		port map (
			DOA		=> open,	-- Port A 8-bit Data Output
			DOB		=> oAnalog,	-- Port B 8-bit Data Output
			DOPA	=> open,	-- Port A 1-bit Parity Output
			DOPB	=> open,	-- Port B 1-bit Parity Output
			ADDRA	=> ADDRA,	-- Port A 11-bit Address Input
			ADDRB	=> ADDRB,	-- Port B 11-bit Address Input
			CLKA	=> Clock,	-- Port A Clock
			CLKB	=> Clock,	-- Port B Clock
			DIA		=> iAnalog,	-- Port A 8-bit Data Input
			DIB		=> X"00",	-- Port B 8-bit Data Input
			DIPA	=> "0",		-- Port A 1-bit parity Input
			DIPB	=> "0",		-- Port-B 1-bit parity Input
			ENA		=> '1',		-- Port A RAM Enable Input
			ENB		=> '1',		-- PortB RAM Enable Input
			SSRA	=> '0',		-- Port A Synchronous Set/Reset Input
			SSRB	=> '0',		-- Port B Synchronous Set/Reset Input
			WEA		=> '1',		-- Port A Write Enable Input
			WEB		=> '0'		-- Port B Write Enable Input
		);
		
end Behavioral;

