/***********************************************************************/
/*                                                                     */
/*  FILE        :DigitalOsc02.c                                        */
/*  DATE        :Thu, Feb 04, 2010                                     */
/*  DESCRIPTION :main program file.                                    */
/*  CPU GROUP   :2A(ROM96K)                                            */
/*                                                                     */
/*  This file is generated by KPIT GNU Project Generator.              */
/*                                                                     */
/***********************************************************************/


#include <stdlib.h>
#include "iodefine.h"
#include "r8c_macro.h"
#include "r8c_uart.h"
#include "r8c_utils.h"
#include "ff.h"
#include "Font.h"
#include "DigitalOsc02.h"
//-----------------------------------------------------------------------
//
//	O[oϐ
//
//-----------------------------------------------------------------------

const WORD SweepTime[] =
	{0, 1, 4, 9, 24, 49, 99, 124, 249, 624, 1249, 2499, 6249, 12499, 24999, 62499};
	
const char TimeParDiv[][9] =
	{	"0.8us/dv", "1.6us/dv", "4.0us/dv", "8.0us/dv", " 20us/dv", " 40us/dv", " 80us/dv",
		"0.1ms/dv", "0.2ms/dv", "0.5ms/dv", "1.0ms/dv", "2.0ms/dv", "5.0ms/dv",
		" 10ms/dv", " 20ms/dv", " 50ms/dv" };
		
const char ModeName[][9] =
	{	" SWEEP", " DELAY", " SLOPE", " TRIG_LV", " INPUT", " VSCALE", " VPOS", " INTENS" };

static FATFS fs;
TKeyInf KeyInf;
TDSOInf DSOInf;
TAppInf AppInf;

//-----------------------------------------------------------------------
//
//	e튄荞݃[`
//
//-----------------------------------------------------------------------

//CvbgLv`荞
void _timer_rc(void) __attribute__ ((interrupt));
void _timer_rc(void)
{
	BYTE d = p5.byte;
	
	
	if ( trcgrc>500 || (trcsr.byte & _BV(OVF_TRC))!=0 ) {
		trc = 0;
		trcsr.byte &= ~_BV(OVF_TRC);
		
		// ]𔻒肵ăJEg𑝌܂
		if ( d & _BV(IO_ENCA) ) {
			if ( d & _BV(IO_ENCB) )
				KeyInf.rot_count -= 1;
			else
				KeyInf.rot_count += 1;
		}
		else {
			if ( d & _BV(IO_ENCB) )
				KeyInf.rot_count += 1;
			else
				KeyInf.rot_count -= 1;
		}
	}
		
	//tONA
	trcsr.byte &= ~_BV(IMFD_TRC);
}
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
//
//	CvO
//
//-----------------------------------------------------------------------

//Gg[|Cg
int main (void)
{
	//vȌ
	initProgram();
	loadConfig();
	configureFPGA();

    while (1) {
		
		//1msɎs
		if ( ir_trbic!=0 ) {
			ir_trbic = 0;
			updateKeyInput();
			
			//50msɎs
			if ( ++AppInf.tim0>=50 ) {
				AppInf.tim0 = 0;
				autoSave();
				updateDSO();
			}
		}
    }

	return (0);
}
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
//
//	FPGAo͏
//
//-----------------------------------------------------------------------

// fW^IV̏ԂXV܂
void updateDSO()
{
	short temp;
	char buff[9];
	
	// GR[_̑ʂ擾܂
	DI();
	temp = KeyInf.rot_count;
	KeyInf.rot_count = 0;
	EI();
	
	// NbN͂Őݒ胂[hύX
	if ( KeyInf.click==1 ) {
		KeyInf.click = 0;
		
		strcpy(buff, ModeName[DSOInf.enter]);
		
		//[hIɖ߂܂
		if ( DSOInf.mode!=MODE_SELECT )
			DSOInf.mode = MODE_SELECT;
			
		//p[^ݒɓ܂
		else {
			DSOInf.mode = DSOInf.enter;
			buff[0] = 0xb1;
		}
			
		puts_dso(LINE_SELECT, buff);
	}
	
	// ͂ꍇ͐ݒXV܂
	if ( temp!=0 ) {
		
		switch ( DSOInf.mode ) {
			case MODE_SELECT:
			updateModeSelect(temp);
			break;
			
			case MODE_SWEEP:
			updateSweepTime(temp);
			break;
			
			case MODE_DELAY:
			updateDelayTime(temp);
			break;
			
			case MODE_SLOPE:
			updateSlope(temp);
			break;
			
			case MODE_LEVEL:
			updateTrigLevel(temp);
			break;
			
			case MODE_INPUT:
			updateInput(temp);
			break;
			
			case MODE_VSCALE:
			updateVScale(temp);
			break;
			
			case MODE_VPOS:
			updateVPosition(temp);
			break;
			
			case MODE_INTENSITY:
			updateIntensity(temp);
			break;
		}
	}
}
//-----------------------------------------------------------------------

//[hI܂
void updateModeSelect(short temp)
{
	temp += DSOInf.enter;
	if ( temp<0 )
		temp = 0;
	else if ( temp>7 )
		temp = 7;
		
	DSOInf.enter = temp;
	puts_dso(LINE_SELECT, ModeName[temp]);
}
//-----------------------------------------------------------------------

//gK̃X[vI܂
void updateSlope(short temp)
{
	char buff[] = "SLOPE   ";
	
	temp += DSOInf.slope;
	if ( temp<1 )
		temp = 1;
	else if ( temp>3 )
		temp = 3;

	DSOInf.slope = temp;
	
	if ( DSOInf.slope & SLOPE_RISE )
		buff[6] = 0xb6;
	if ( DSOInf.slope & SLOPE_FALL )
		buff[7] = 0xb7;
	
	puts_dso(LINE_SLOPE, buff);
	setSlope(DSOInf.slope);
}
//-----------------------------------------------------------------------

//|ԂXV܂
void updateSweepTime(short temp)
{
	temp += DSOInf.sweep;
	if ( temp<0 )
		temp = 0;
	else if ( temp>15 )
		temp = 15;

	DSOInf.sweep = temp;
	setSweepTime(SweepTime[temp]);
	
	//|Ԃ\܂
	puts_dso(LINE_SWEEP-10, TimeParDiv[temp]);
}
//-----------------------------------------------------------------------

//gKxXV܂
void updateTrigLevel(short temp)
{
	temp += DSOInf.level;
	if ( temp<0 )
		temp = 0;
	else if ( temp>255 )
		temp = 255;
		
	DSOInf.level = temp;
	setTrigLevel(temp);
}
//-----------------------------------------------------------------------

//|WVXV܂
void updateVPosition(short temp)
{
	temp += DSOInf.vpos;
	if ( temp<0 )
		temp = 0;
	else if ( temp>255 )
		temp = 255;
		
	DSOInf.vpos = temp;
	da1.byte = temp;
}
//-----------------------------------------------------------------------

//PxXV܂
void updateIntensity(short temp)
{
	char buff[9];
	
	temp += DSOInf.intensity;
	if ( temp<0 )
		temp = 0;
	else if ( temp>15 )
		temp = 15;
		
	DSOInf.intensity = temp;
	setIntensity(temp);
	
	
	//Px\܂
	sprintf(buff, " %d", temp);
	puts_dso(LINE_INTENSITY-10, buff);
}
//-----------------------------------------------------------------------

//xԂXV܂
void updateDelayTime(short temp)
{
	char buff[20];
	WORD u, l;
	
	//΂₭Ƃ͑ʂӂ₵܂
	if ( temp>2 )
		temp = 40;
	else if ( temp<-2 )
		temp = -40;
	
	temp += DSOInf.delay;
	if ( temp<0 )
		temp = 0;
	else if ( temp>2047 )
		temp = 2047;
		
	DSOInf.delay = temp;
	setDelayTime(temp);
	
	
	//xԂ\܂
	u = temp * 25;
	l = u % 1000;
	u /= 1000;
	sprintf(buff, "%d.%03d", u, l);
	puts_dso(LINE_DELAY-10, buff);
}
//-----------------------------------------------------------------------

//̓JbvOݒ肵܂
void updateInput(short temp)
{
	//DCJbvOɂ܂
	if ( temp>0 ) {
		puts_dso(LINE_INPUT, "INPUT DC");
		RELAY_AC = 0;
	}
	
	//ACJbvOɂ܂
	else {
		puts_dso(LINE_INPUT, "INPUT AC");
		RELAY_AC = 1;
	}
}
//-----------------------------------------------------------------------

//Abel[^ݒ肵܂
void updateVScale(short temp)
{
	//0.1V/divɐݒ
	if ( temp>0 ) {
		puts_dso(LINE_VSCALE, "0.1V/div");
		RELAY_ATT = 0;
	}
	
	//0.2V/divɐݒ
	else {
		puts_dso(LINE_VSCALE, "0.2V/div");
		RELAY_ATT = 1;
	}
}
//-----------------------------------------------------------------------

//fW^IV̐ݒ܂
void initDSO()
{
//	char buf0[] = {0x92, 0xb3, 0x8b, 0xb3, 0x8f, 0xa8, 0x00};
//	char buf1[] = {0x84, 0x8b, 0xaa, 0x8c, 0x89, 0xb0, 0x9b, 0xb4, 0x00};
	
	//x`悵܂
//	puts_dso(240, buf0);
//	puts_dso(230, buf1);
	puts_dso(LINE_SWEEP, "SWEEP");
	puts_dso(LINE_DELAY, "DELAY");
	puts_dso(LINE_INTENSITY, "INTENS");
	
	//lݒE`悵܂
	updateModeSelect(0);
	updateSweepTime(0);
	updateDelayTime(0);
	updateSlope(0);
	updateTrigLevel(0);
	updateInput(1);
	updateVScale(1);
	updateVPosition(0);
	updateIntensity(0);
}
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
//
//	FPGA჌xʐMAPI
//
//-----------------------------------------------------------------------

//|Ԃݒ肵܂
void setSweepTime(WORD time)
{
	FPGA_DC = 1;
	xmit_fpga(FPGA_SWEEP);
	FPGA_DC = 0;
	xmit_fpga(WORD_LO(time));
	xmit_fpga(WORD_HI(time));
}
//-----------------------------------------------------------------------

//X[vݒ肵܂
void setSlope(BYTE slope)
{
	FPGA_DC = 1;
	xmit_fpga(FPGA_SLOPE);
	FPGA_DC = 0;
	xmit_fpga(slope);
}
//-----------------------------------------------------------------------

//gKxݒ肵܂
void setTrigLevel(BYTE level)
{
	FPGA_DC = 1;
	xmit_fpga(FPGA_LEVEL);
	FPGA_DC = 0;
	xmit_fpga(level);
}
//-----------------------------------------------------------------------

//Pxݒ肵܂
void setIntensity(BYTE level)
{
	FPGA_DC = 1;
	xmit_fpga(FPGA_INTENSITY);
	FPGA_DC = 0;
	xmit_fpga(level);
}
//-----------------------------------------------------------------------

//xԂݒ肵܂
void setDelayTime(WORD time)
{
	FPGA_DC = 1;
	xmit_fpga(FPGA_DELAY);
	FPGA_DC = 0;
	xmit_fpga(WORD_LO(time));
	xmit_fpga(WORD_HI(time));
}
//-----------------------------------------------------------------------

//FPGAɕo͂܂
void puts_dso(BYTE ln, const char* s)
{
	BYTE i;
	BYTE buff[8];
	const BYTE* c = s;
	
	//̒8ɐBG[`FbN
	for ( i=0; i<8; i++ ) {
		
		if ( c[i]=='\0' ) {
			for ( ; i<8; i++ ) buff[i] = 0;
			break;
		}
		
		buff[i] = c[i] - ' ';
		if ( buff[i]<0 || buff[i]>191 ) buff[i] = 0;
	}
	
	//wb_̑M
	FPGA_DC = 1;
	xmit_fpga(FPGA_BMP);
	FPGA_DC = 0;
	xmit_fpga(ln);
	
	//FPGAɃf[^𑗐M܂
	for ( i=0; i<8; i++ ) {
		xmit_fpga(Font[ buff[0] ][i]);
		xmit_fpga(Font[ buff[1] ][i]);
		xmit_fpga(Font[ buff[2] ][i]);
		xmit_fpga(Font[ buff[3] ][i]);
		xmit_fpga(Font[ buff[4] ][i]);
		xmit_fpga(Font[ buff[5] ][i]);
		xmit_fpga(Font[ buff[6] ][i]);
		xmit_fpga(Font[ buff[7] ][i]);
	}
}
//-----------------------------------------------------------------------

//FPGARtBM[V܂
void configureFPGA()
{
	FIL fp;
	FRESULT res;
	BYTE buff[100];
	UINT i, n;
	
	//RtBM[V̊Jn
	uart_puts("begin configuration of FPGA.\r\n");
	
	
	// bitstreamt@CJ܂B
	res = f_open(&fp, "dso_conf.bit", FA_READ | FA_OPEN_EXISTING);
	if ( res!=FR_OK ) {
		
		f_close(&fp);
		uart_puts(STR_FRESULT[res]);
		uart_puts("configuration failed.\r\n");
		return;
	}

	// SPIW[Ȍ
	DI();
	u0mr.byte = _BV(SMD0);		//NbNVAI/O
	u0brg.byte = 0;				//NbNȂ
	u0c0.byte = _BV(UFORM);		//SPI Mode0 MSB first
	u0c1.byte = _BV(TE);		//M
	s0tic.byte = 0;				//荞݂Ȃ
	s0ric.byte = 0;
	EI();

	// RtBM[VJn
	FPGA_PROG = 0;
	wait(1);
	FPGA_PROG = 1;
	wait(10);
	
	// FPGARtBM[V[v
	do {
		res = f_read(&fp, buff, 100, &n);
		for ( i=0; i<n; i++ ) {
			xmit_fpga(buff[i]);
		}
			
	} while ( n==100 );
	f_close(&fp);
	
	
	// FPGAXe[^X`FbN
	if ( FPGA_DONE!=0 )
		uart_puts("configuration succeeded.\r\n");
	else
		uart_puts("configuration failed.\r\n");
	
	// FPGAZbgON-OFF
	wait(999);
	FPGA_DC = 0;
	xmit_fpga(FPGA_RESET);
	FPGA_DC = 1;
	xmit_fpga(FPGA_RESET);
	xmit_fpga(FPGA_RUN);
	initDSO();
}
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
//
//	L[͊֘A
//
//-----------------------------------------------------------------------

//L[͂o܂
void updateKeyInput()
{
	BYTE d = p5.byte;
	
	// ͑ҋ@
	if ( KeyInf.click_wait>0 )
		KeyInf.click_wait--;
		
	else {
	
		// L[̗͂o܂
		if ( (d & _BV(IO_ENCSW))==0 && (KeyInf.buff & _BV(IO_ENCSW))!=0 ) {
	
			KeyInf.click_wait = 10;
			KeyInf.click = 1;
		}
		KeyInf.buff = d;
	}
}
//-----------------------------------------------------------------------

//L[͈莞ԌoߌAݒۑ܂
void autoSave()
{
	CHAR temp = KeyInf.rot_count;
	
	//ݒύXo
	if ( temp!=0 ) {
		AppInf.auto_save = 1;
	}
	
	//ݒύXA3bԓ͂Ȃΐݒۑ
	else if ( AppInf.auto_save>60 ) {
		AppInf.auto_save = 0;
		saveConfig();
	}
	
	//3bԑ҂
	else if ( AppInf.auto_save>0 ) {
		AppInf.auto_save++;
	}
}
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
//
//	\bh
//
//-----------------------------------------------------------------------

//vȌ
void initProgram()
{
	BYTE i;
	
//---------- 荞݋֎~ ----------
	DI();

	
//---------- IO|[g̏ ----------
	prc2 = 1;						//PD0ɂ̓veNgB
	pd0.byte = ~_BV(IO_VPOS);		//DAo͂ɕt͐ݒ

	p1.byte = 0;
	pd1.byte = 0xff;
	
	p2.byte = 0;
	pd2.byte = ~_BV(IO_FPGADONE);	//FPGA_DONE
	
	p3.byte = 0;
	pd3.byte = ~_BV(IO_TSW);		//XCb`
	
	p4.byte = 0;
	pd4.byte = 0x3f;
	
	p5.byte = 0;
	pd5.byte = ~(_BV(IO_ENCSW) |_BV(IO_ENCA) |_BV(IO_ENCB));
	
	p6.byte = 0;
	pd6.byte = ~(_BV(IO_MMCRX) |_BV(IO_UARTRX));
	
	p8.byte = 0;
	pd8.byte = 0xff;
	
	
//---------- doH̏ ----------
	vca26 = 1;
	wait(200);
	vw1c.byte = 0xea;
	vw1c0 = 1;


//---------- IV[^̏ ----------
	prc0 = 1;
	cm06 = 1;	//NbN8
	cm13 = 1;	//XIN-XOUT[qL
	cm05 = 1;	//UڑɕtXINNbN~
	wait(100);
	ocd2 = 0;	//VXeNbNXIN
	cm14 = 1;	//ᑬI`bvIV[^~
	cm06 = 0;	//NbNȂ
//	cm04 = 1;	//XCIN-XCOUT[qL
	prc0 = 0;
	wait(100);
	

//---------- TimerRȀ ----------
	trapre.byte = 199;
	tra.byte = 124;
	tramr.byte = _BV(TCK0_TRA);
	traioc.byte = 0;
	tracr.byte = _BV(TSTART_TRA);
	traic.byte = 4;			//荞݃xS
	

//---------- TimerRB̏ ----------
	trbioc.byte = 0;
	trbmr.byte = 0;
//	trbmr.byte = _BV(TCK0_TRB);
	trbpre.byte = 199;
	trbpr.byte = 99;
	trbic.byte = 0;			//荞݋֎~
	trbcr.byte = _BV(TSTART_TRB);
	
	
//---------- TimerRC̏ ----------
	mst_trc = 1;
	trccr1.byte = _BV(TCK2_TRC);
	trcier.byte = _BV(IMIED_TRC);
//	trcdf.byte = _BV(DFC_TRC) |_BV(DFCK1_TRC) |_BV(DFCK0_TRC);
//	trcdf.byte = _BV(DFC_TRC);
	trcior0.byte = _BV(IOA3_TRC);
	trcior1.byte = _BV(IOD1_TRC) |_BV(IOD2_TRC);
	trcmr.byte = _BV(PWM2_TRC) |_BV(TSTART_TRC);
	trcic.byte = 3;			//荞݃xR
	
	
//---------- D/Ȁ ----------
	dacon0.byte = _BV(DA1E);
	da1.byte = 127;


//---------- ӃW[̏ ----------
	uart_init();


//---------- 荞݂̋ ----------
	IPL(0);
	EI();
	
	
//---------- ϐ̏ ----------
	KeyInf.buff = p5.byte;
	KeyInf.click = 0;
	KeyInf.click_wait = 0;
	KeyInf.rot_count = 0;
	
	DSOInf.sweep = 0;
	DSOInf.slope = SLOPE_RISE;
	DSOInf.level = 64;
	DSOInf.vpos = 127;
	DSOInf.intensity = 8;
	DSOInf.delay = 0;
	DSOInf.mode = MODE_SELECT;
	FPGA_PROG = 1;
	
	f_mount(0, &fs);
}
//-----------------------------------------------------------------------

//ݒǂݍ݂܂
void loadConfig()
{
	FIL fp;
	FRESULT res;
	char buff[30];
	short temp;
	
	
	//ݒt@Cs݂̏ꍇ́AXLbv
	res = f_open(&fp, "dso_conf.ini", FA_READ | FA_OPEN_EXISTING);
	if ( res!=FR_OK ) goto END_CONFIGURATION;
	
	//|xǂݍ
	readString(&fp, buff, "SWEEP");
	temp = atoi(buff);
	if ( 0<=temp && temp<=15 )
		DSOInf.sweep = temp;
	
	//gKxǂݍ	
	readString(&fp, buff, "TRIGLV");
	temp = atoi(buff);
	if ( 0<=temp && temp<=255 )
		DSOInf.level = temp;

	//ʒuǂݍ
	readString(&fp, buff, "VPOS");
	temp = atoi(buff);
	if ( 0<=temp && temp<=255 )
		DSOInf.vpos = temp;

	//Pxǂݍ
	readString(&fp, buff, "INTENS");
	temp = atoi(buff);
	if ( 0<=temp && temp<=15 )
		DSOInf.intensity = temp;

END_CONFIGURATION:
	f_close(&fp);
	return;
}
//-----------------------------------------------------------------------

//ݒo܂
void saveConfig()
{
	FIL fp;
	FRESULT res;
	
	
	//sꍇ̓XLbv
	res = f_open(&fp, "dso_conf.ini", FA_WRITE | FA_OPEN_ALWAYS);
	if ( res!=FR_OK ) goto END_CONFIGURATION;
	f_sync(&fp);
	
	//|x݂܂
	f_printf(&fp, "SWEEP=%d\r\n", (int)DSOInf.sweep);
	
	//gKx݂܂
	f_printf(&fp, "TRIGLV=%d\r\n", (int)DSOInf.level);

	//ʒu݂܂
	f_printf(&fp, "VPOS=%d\r\n", (int)DSOInf.vpos);

	//Px݂܂
	f_printf(&fp, "INTENS=%d\r\n", (int)DSOInf.intensity);

END_CONFIGURATION:
	f_close(&fp);
	return;
}
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
//
//	̑
//
//-----------------------------------------------------------------------

//FatFsp̌ݎԂԂ܂B
DWORD get_fattime ()
{
	return	  ((DWORD)(2008 - 1980) << 25)
			| ((DWORD)5 << 21)
			| ((DWORD)14 << 16)
			| ((DWORD)3 << 11)
			| ((DWORD)23 << 5)
			| ((DWORD)0 >> 1);
}
//-----------------------------------------------------------------------

