#ifndef DIGITALOSC02H
#define DIGITALOSC02H

//-----------------------------------------------------------------------
//
//	DigitalOsc02vOwb_
//	100204
//
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
//
//	e萔A`
//
//-----------------------------------------------------------------------

// Port0 IO`
#define IO_VPOS		7


// Port1 IO`
#define IO_MMCCS	1
#define	IO_FPGADI	4
#define	IO_FPGACLK	6
#define MMC_CS		p1.bit.b1


// Port2 IO`
#define	IO_FPGADONE	0
#define IO_FPGADC	1
#define	FPGA_DONE	p2.bit.b0
#define	FPGA_DC		p2.bit.b1


// Port3 IO`
#define IO_TSW		5


// Port5 IO`
#define IO_RLAC		0
#define IO_RLATT	1
#define	IO_ENCSW	2
#define	IO_ENCB		3
#define	IO_ENCA		4
#define RELAY_AC	p5.bit.b0
#define RELAY_ATT	p5.bit.b1


// Port6 IO`
#define	IO_FPGAPROG	0
#define IO_MMCTX	3
#define IO_MMCRX	4
#define IO_MMCCLK	5
#define IO_UARTTX	6
#define IO_UARTRX	7
#define	FPGA_PROG	p6.bit.b0


// FPGA R}h
#define	FPGA_RESET		0x00
#define	FPGA_RUN		0x01
#define FPGA_SWEEP		0x10
#define FPGA_LEVEL		0x11
#define FPGA_BMP		0x12
#define	FPGA_INTENSITY	0x13
#define	FPGA_DELAY		0x14
#define	FPGA_SLOPE		0x15


// L[͏
typedef struct _key_inf {
	BYTE	buff;
	BYTE	click;
	BYTE	click_wait;
	CHAR	rot_count;
}TKeyInf;


// fW^IṼp[^
#define		MODE_SELECT		-1
#define		MODE_SWEEP		0
#define		MODE_DELAY		1
#define		MODE_SLOPE		2
#define		MODE_LEVEL		3
#define		MODE_INPUT		4
#define		MODE_VSCALE		5
#define		MODE_VPOS		6
#define		MODE_INTENSITY	7

#define		LINE_SELECT		220
#define		LINE_SLOPE		200
#define		LINE_SWEEP		180
#define		LINE_DELAY		150
#define		LINE_INPUT		120
#define		LINE_VSCALE		110
#define		LINE_INTENSITY	90

#define		SLOPE_RISE		1
#define		SLOPE_FALL		2
#define		SLOPE_BOTH		3
typedef struct _dso_inf {
	CHAR	mode;
	BYTE	enter;
	BYTE	slope;
	BYTE	sweep;
	BYTE	level;
	BYTE	vpos;
	BYTE	intensity;
	short	delay;
}TDSOInf;


// AvP[Vf[^
typedef struct _app_inf {
	BYTE	tim0;
	BYTE	auto_save;
}TAppInf;

//-----------------------------------------------------------------------
//
//	e֐A錾
//
//-----------------------------------------------------------------------

// vO
// init@C̃[h
// p[^̕ۑ
// I[gZ[u
void initProgram();
void loadConfig();
void saveConfig();
void autoSave();

// FPGÃRtBM[V
void configureFPGA();

// DSO̊ep[^XV܂
void updateDSO();
void updateModeSelect(short rot);
void updateSweepTime(short rot);
void updateSlope(short rot);
void updateDelayTime(short rot);
void updateTrigLevel(short rot);
void updateInput(short rot);
void updateVScale(short rot);
void updateVPosition(short rot);
void updateIntensity(short rot);

// DSOɊeݒo͂܂
void setSweepTime(WORD time);
void setSlope(BYTE slope);
void setTrigLevel(BYTE level);
void setIntensity(BYTE level);
void setDelayTime(WORD time);

// DSÕp[^܂
// j[ɕ1so͂܂
void initDSO();
void puts_dso(BYTE ln, const char* s);

// L[̓`FbN
void updateKeyInput();


//FPGA SPIM
#define xmit_fpga(dat) 	u0tbl=(dat); while( txept_u0c0==0 )


#endif
