#ifndef R8C_MACROH
#define R8C_MACROH

//-----------------------------------------------------------------------                  
//	`Ƃ
//-----------------------------------------------------------------------                  

#include "integer.h"


//DWORD`
typedef union {
	struct {
		BYTE	byte0;
		BYTE	byte1;
		BYTE	byte2;
		BYTE	byte3;
	}byte;
	
	struct {
		WORD	word0;
		WORD	word1;
	}word;
	
	DWORD dword;
}dword_def;


//WORD`
typedef union {
	struct {
		BYTE	lo;
		BYTE	hi;
	}byte;
	
	WORD word;
}word_def;


//rbgtO
#define _BV(addr) (1<<(addr))
#define bit_is_set(addr,bit)	( ( (addr)&( 1<<(bit) ) )!=0 )
#define bit_is_clear(addr,bit)	( ( (addr)&( 1<<(bit) ) )==0 )

//荞ݐݒ}N
#define EI() asm("NOP\n\t"\
				 "NOP\n\t"\
				 "FSET I");
				 
#define DI() asm("FCLR I")
#define IPL(lv) asm("LDIPL %0" : : "i" (lv)) 


//oCgANZX
#define		WORD_LO(dat)		(((word_def*)(&dat))->byte.lo)
#define		WORD_HI(dat)		(((word_def*)(&dat))->byte.hi)
#define		DWORD_BYTE0(dat)	(((dword_def*)(&dat))->byte.byte0)
#define		DWORD_BYTE1(dat)	(((dword_def*)(&dat))->byte.byte1)
#define		DWORD_BYTE2(dat)	(((dword_def*)(&dat))->byte.byte2)
#define		DWORD_BYTE3(dat)	(((dword_def*)(&dat))->byte.byte3)


//-----------------------------------------------------------------------                  
//	WX^rbg`
//-----------------------------------------------------------------------                  


/*------------------------------------------------------
  interrupt bit
------------------------------------------------------*/
#define		ILVL0		0
#define		ILVL1		1
#define		ILVL2		2
#define		IR			3


/*------------------------------------------------------
  UARTi transmit/receive mode register
------------------------------------------------------*/
#define		SMD0		0		/* Serial I/O mode select bit */
#define		SMD1		1		/* Serial I/O mode select bit */
#define		SMD2		2		/* Serial I/O mode select bit */
#define		CKDIR		3		/* Internal/external clock select bit */
#define		STPS		4		/* Stop bit length select bit */
#define		PRY			5		/* Odd/even parity select bit */
#define		PRYE		6		/* Parity enable bit */


/*------------------------------------------------------
  UARTi transmit/receive control register0
------------------------------------------------------*/
#define		CLK0		0		/* BRG count source select bit */
#define		CLK1		1		/* BRG count source select bit */
#define		TXEPT		3		/* Transmit register empty flag */
#define		NCH			5		/* Data output select bit */
#define		CKPOL		6		/* CLK polarity select bit */
#define		UFORM		7		/* Transfer format select bit */


/*------------------------------------------------------
  UARTi transmit/receive control register1
------------------------------------------------------*/
#define		TE			0		/* Transmit enable bit */
#define		TI			1		/* Transmit buffer empty flag */
#define		RE			2		/* Receive enable bit */
#define		RI			3		/* Receive complete flag */
#define		IRS			4		/* UART0 transmit interrupt cause select bit */
#define		RRM			5		/* UART0 continuous receive mode enable bit */


/*------------------------------------------------------
  UARTi receive buffer register
------------------------------------------------------*/
#define		OER			4		/* Overrun error flag */
#define		FER			5		/* Framing error flag */
#define		PER			6		/* Parity error flag */
#define		SUM			7		/* Error sum flag */


#endif
